import java.util.*;

class Producer
extends Thread
{
  private Vector v;
  int limit;
  int number;

  public Producer(Vector v, int limit, int number)
  {
    this.v = v;
    this.limit = limit;
    this.number = number;
  }

  public void run()
  {
    String s;

    while (true) {
      s = "Wert "+Math.random();
      synchronized (v) {
      	while (v.size() == limit) { // Lager ist voll
          try {
          	System.out.println("                    Produzent " + number + " is waiting");
            v.wait();
          } catch (InterruptedException e) {
            //nichts
          }
    	}
        v.addElement(s);
        System.out.println("                    Produzent " + number + " erzeugte "+s);
        v.notify();
      }
      try {
        Thread.sleep((int)(10*Math.random()));
      } catch (InterruptedException e) {
        //nichts
      }
    }
  }
}

class Consumer
extends Thread
{
   private Vector v;
   int number;

   public Consumer(Vector v, int number)
   {
      this.v = v;
      this.number = number;
   }

   public void run()
   {
      while (true) {
         synchronized (v) {
            while (v.size() < 1) { // Lager ist leer
               try {
          	      System.out.println("Konsument " + number + " is waiting");               	
                  v.wait();
               } catch (InterruptedException e) {
                  //nichts
               }
            }
            System.out.print(
              "Konsument " + number + " fand "+(String)v.elementAt(0)
            );
            v.removeElementAt(0);
            System.out.println(" (verbleiben: "+v.size()+")");
            v.notify();
         }
         try {
            Thread.sleep((int)(10*Math.random()));
         } catch (InterruptedException e) {
            //nichts
         }
      }
   }
}

public class ManyProducerManyConsumerLimited
{
   public static void main(String[] args)
   {
      final int ANZAHL_CONSUMER = 2;
      final int ANZAHL_PRODUCER = 2;
      final int LIMIT  = 1;
      Vector v = new Vector(LIMIT);
      
      Producer[] p = new Producer[ANZAHL_PRODUCER];
            
      for (int i = 0; i < ANZAHL_PRODUCER; i++)
      {
      	p[i] = new Producer(v, LIMIT, i);
      	p[i].start();
      }      
      
      Consumer[] c = new Consumer[ANZAHL_CONSUMER];
            
      for (int i = 0; i < ANZAHL_CONSUMER; i++)
      {
      	c[i] = new Consumer(v, i);
      	c[i].start();
      }
   }
}