import java.util.*;

class Producer
extends Thread
{
  int limit;
  private Vector v;

  public Producer(Vector v, int limit)
  {
    this.v = v;
    this.limit = limit;
  }

  public void run()
  {
    String s;

    while (true) {
      s = "Wert "+Math.random();	
      synchronized (v) {
      	while (v.size() == limit) {
          try {
            v.wait();
          } catch (InterruptedException e) {
            //nichts
          }
        }
        v.addElement(s);
        System.out.println("                    Produzent erzeugte "+s);
        v.notify();
      }
      try {
        Thread.sleep((int)(90*Math.random()));
      } catch (InterruptedException e) {
        //nichts
      }
    }
  }
}

class Consumer
extends Thread
{
   private Vector v;

   public Consumer(Vector v)
   {
      this.v = v;
   }

   public void run()
   {
      while (true) {
         synchronized (v) {
            while (v.size() < 1) {
               try {
                  v.wait();
               } catch (InterruptedException e) {
                  //nichts
               }
            }
            System.out.print(
              "Konsument fand "+(String)v.elementAt(0)
            );
            v.removeElementAt(0);
            System.out.println(" (verbleiben: "+v.size()+")");
            v.notify();
         }
         try {
            Thread.sleep((int)(100*Math.random()));
         } catch (InterruptedException e) {
            //nichts
         }
      }
   }
}

public class ProducerConsumerLimitedWithoutDeadlock
{
   public static void main(String[] args)
   {
      final int LIMIT = 3;  // Kapazitt des Lagers
      Vector v = new Vector();

      Producer p = new Producer(v, LIMIT);
      Consumer c = new Consumer(v);
      p.start();
      c.start();
   }
}