import java.util.*;

class Producer
extends Thread
{
  private Vector v;

  public Producer(Vector v)
  {
    this.v = v;
  }

  public void run()
  {
    String s;

    while (true) {
      s = "Wert "+Math.random();	
      synchronized (v) {
        v.addElement(s);
        System.out.println("Produzent erzeugte "+s);
        v.notify();
      }
      try {
        Thread.sleep((int)(100*Math.random()));
      } catch (InterruptedException e) {
        //nichts
      }
    }
  }
}

class Consumer
extends Thread
{
   private Vector v;

   public Consumer(Vector v)
   {
      this.v = v;
   }

   public void run()
   {
      while (true) {
         synchronized (v) {
            while (v.size() < 1) {
               try {
                  Thread.sleep(100);
               } catch (InterruptedException e) {
                  //nichts
               }
            }
            System.out.print(
              "                    Konsument fand "+(String)v.elementAt(0)
            );
            v.removeElementAt(0);
            System.out.println(" (verbleiben: "+v.size()+")");
         }
         try {
            Thread.sleep((int)(100*Math.random()));
         } catch (InterruptedException e) {
            //nichts
         }
      }
   }
}

public class ProducerConsumerMitSleep
{
   public static void main(String[] args)
   {
      Vector v = new Vector();

      Producer p = new Producer(v);
      Consumer c = new Consumer(v);
      p.start();
      c.start();
   }
}